add.legend <- function(xp, yp, vals, horiz=T, xjust=.5, line=1,col=1, yjust=.5,lwd=3,lty=1,side,total.reg=F,bg='white',...){
  
  if(total.reg){
    opar <- par()
    par(new=T,mar=c(0,0,0,0),fig=c(0,1,0,1))
    oceanmap::empty.plot()
  }
  if(!missing(side)){
    dims <- par()$usr
    
    par(new=T)
    oceanmap::empty.plot()
    #     if(par()$xlog) dims[1:2] <- log(dims[1:2])
    #     if(par()$ylog) dims[3:4] <- log(dims[3:4])
    
    x0 <- mean(dims[1:2])
    if(side %in% c('t','top') | side %in% 3){
      y0 <- dims[4]+diff(dims[3:4])*.075*line
    }
    
    if(side %in% c('c','center')){
      y0 <- mean(dims[3:4])
    }
    par(xaxs='i',yaxs='i',new=T)
    oceanmap::empty.plot(xlim=dims[1:2],ylim=dims[3:4])
  }else{
    
    if(missing(yp)) yp <- xp
    u <- par()$usr
    xlim <- u[1:2]
    ylim <- u[3:4]
    
    if(xp > 1) xp <- xp/100
    if(yp > 1) yp <- yp/100
    
    x0 <- xlim[1]+xp*diff(xlim)
    y0 <- ylim[1]+yp*diff(ylim)
  }
  
  
  #   if(missing(x) | missing(y)){
  #     p <- locator(n=1)
  #     if(missing(x)) x <- p$x
  #     if(missing(y)) y <- p$y
  #   }
  
  print(1)
  legend(x=x0, y=y0, legend=vals, horiz=horiz, lty=lty, lwd=lwd, xpd=T, col=col, xjust=xjust, yjust=yjust,bg=bg,...)
  if(total.reg) suppressWarnings(par(opar))
}




add.legendp <- function(xp=50, yp=80, vals, horiz=T, xjust=.5, line=1,col=1, yjust=.5,lwd=3,lty=1,total.reg=F,bg='white',mar=c(0,0,0,0),...){
  
  if(total.reg){
    opar <- par()
    par(new=T,mar=mar,fig=c(0,1,0,1))
    empty.plot()
  }else{
    par(new=T)
    oceanmap::empty.plot()
  }
  u <- par()$usr
  xlim <- u[1:2]
  ylim <- u[3:4]
  
  if(xp > 1) xp <- xp/100
  if(yp > 1) yp <- yp/100
  
  x0 <- xlim[1]+xp*diff(xlim)
  y0 <- ylim[1]+yp*diff(ylim)
  
  legend(x=x0, y=y0, legend=vals, horiz=horiz, lty=lty, lwd=lwd, xpd=T, col=col, xjust=xjust, yjust=yjust,bg=bg,...)
  if(total.reg) suppressWarnings(par(opar))
}
