error.band <- function(x, y, upper.y,
                     lower.y=upper.y,col='gray',border=NA,add_y=F,...){
  if(length(x) != length(y) | length(y) !=length(lower.y) |
     length(lower.y) != length(upper.y))
  {stop("vectors must be same length")}
  if(add_y){
    upper.y<-y+upper.y
    lower.y<-y-lower.y
  }
  
  # polygon(c(x,rev(x)),
          # c(lower.y,rev(upper.y)),col=col,border=border,...)
  n <- length(y)
  
  yid <- rep(NA,n)
  i <- id <- 1
  while(i <= n){
    ii <- which(is.na(y) != is.na(y)[i]) # get all record ids with same "on.surface"-signature (value)
    i2 <- ii[which(ii > i)][1] # jump to next presence-absence change
    if(is.na(i2)) i2 <- n+1 # in case of last record
    yid[i:(i2-1)] <- id
    id <- id+1
    i <- i2
  }
  
  kk <- unique(yid[which(!is.na(y))])
  for(k in kk){
    jj <- which(yid == k)
    polygon(c(x[jj],rev(x[jj])),
            c(lower.y[jj],rev(upper.y[jj])),col=col,border=border,...)
  }
}
