

#### get Blue Med meta data:
get.meta_bluemed <- function(Serial,Ptt,year,only_recovered=F,bluemed_path="~/bluemed/"){
  if(!file.exists(bluemed_path)) stop('could not find bluemed folder! please revise!')
  owd <- getwd()
  mf <- paste0(bluemed_path,'/data/')
  
  setwd(mf)
  meta <- read.csv(Sys.glob('*meta*.csv'),stringsAsFactors=F)
  head(meta)
  #   lct <- Sys.getlocale("LC_TIME"); Sys.setlocale("LC_TIME", "C")
  i <- which(grepl('\\/',meta$dep.date))
  if(length(i) > 0){
    if(length(i) != nrow(meta)) stop('different formats found for deployment dates. please revise!')
    meta$dep.date <- strptime(meta$dep.date,'%m/%d/%Y %H:%M',tz = "UTC")
  }else{
    meta$dep.date <- strptime(meta$dep.date,'%d-%b-%Y %H:%M',tz = "UTC")
  }
  # head(meta)
  meta$prog.rel.date <- as.Date(meta$prog.rel.date, "%d-%b-%y")
  
  j <- which(grepl('\\/',meta$pop.date))
  if(length(i) > 0){
    if(length(i) != nrow(meta)) stop('different formats found for pop-up dates. please revise!')
    meta$pop.date <- strptime(meta$pop.date,'%m/%d/%Y %H:%M',tz = "UTC")
  }else{
    meta$pop.date <- strptime(meta$pop.date,'%d-%b-%Y %H:%M',tz = "UTC")
  }
  
  meta$prog.rel.date <- as.Date(meta$prog.rel.date,'%d-%b-%Y')
  # meta$ts.resolution
  ii <- which(lapply(meta,class) == "factor")
  for(i in ii) meta[[names(meta)[i]]] <- as.character(meta[[names(meta)[i]]])
  setwd(owd)
  
  ### skip entries without pop-up date:
  skip <- which(is.na(meta$pop.date))
  if(length(skip) != 0) {
    warning("tag(s): ",paste(meta$Serial[skip],collapse=", "), " without pop-up date and therefore skipped!")
    meta <- meta[-skip,]
  }
  
  meta0 <- meta
  if(!missing(Ptt)) meta <- meta0[which(meta0$Ptt %in% Ptt),]
  if(!missing(Serial)) meta <- meta0[which(meta0$Serial %in% Serial),]
  meta <- meta[order(meta$dep.date),]
  meta$dep.year <- as.numeric(format(as.Date(meta$dep.date),"%Y"))
  if(!missing(year)) meta <- meta[which(meta$dep.year %in% year),]
  if(only_recovered) meta <- meta[which(meta$recovered),]
  
  return(meta)
}

