merge.multi_args <- function(x0,y0,by,by.x=by,by.y=by.x,...){
  x0.bkp <- x0
  y0.bkp <- y0
  x0$key <- y0$key <- c()
  for(i in by.x) {
    x0$key <- paste(x0$key,x0[[i]],sep='SEPSTRING')
    x0[[i]] <- c()
  }
  for(i in by.y) {
    y0$key <- paste(y0$key,y0[[i]],sep='SEPSTRING')
    y0[[i]] <- c()
  }
  
  df <- merge(x0,y0,by='key',...)
  NCOL <- length(by)+1
  f <- data.frame(matrix(unlist(strsplit(df$key,'SEPSTRING')),ncol=NCOL,byrow=T))
  f[,1] <- c()
  names(f) <- by.x
  df <- cbind(f,df)
  df$key <- c()
  
  ### reconvert vector classes
  library(lubridate)
  for(vv in by.x){
    if(paste(class(x0.bkp[[vv]]),collapse="_") != paste(class(x0.bkp[[vv]]),collapse="_")) warning(paste0('Class of column "',vv,'" does not match between data-frames!'))
    if(is.numeric(x0.bkp[[vv]]) | is.numeric(y0.bkp[[vv]])) df[[vv]] <- fact2num(df[[vv]])
    if(is.character(x0.bkp[[vv]]) | is.character(y0.bkp[[vv]])) df[[vv]] <- as.character(df[[vv]])
    if(is.Date(x0.bkp[[vv]]) | is.Date(y0.bkp[[vv]])) df[[vv]] <- fact2Date(df[[vv]])
    if(is.POSIXct(y0.bkp[[vv]]) | is.POSIXlt(y0[[vv]]) | is.POSIXct(y0.bkp[[vv]]) | is.POSIXlt(y0.bkp[[vv]])) df[[vv]] <- fact2Date.long(x = df[[vv]],tz='UTC')
    if(is.logical(x0.bkp[[vv]])) {
      a <-  as.character(df[[vv]])
      df[[vv]] <- T
      df[[vv]][which(a == "FALSE")] <- F
    }
  }
#   lapply(df,class)
  
  #   head(df)  
  return(df)
}
