
####### define function to plot:
plot_SpatialTracks <- function(SpatialTracks, show_merged=T){
  library(oceanmap)
  library(lubridate)
  data(cmap)
  sp <- SpatialTracks
  
  df_cols <- data.frame(yday=1:366,col=colorRampPalette(cmap$year.jet)(366),stringsAsFactors = F)
  if(class(sp) == "SpatialPolygonsDataFrame"){
    pols_df <- sp
    ydays <- yday(as.Date(pols_df$date.long))
    cols <- df_cols$col[ydays]
    plot(pols_df,add=T,col=cols,border=cols)
    all <- sp::SpatialPolygons(pols_df@polygons)
    merged <- try(maptools::unionSpatialPolygons(all,IDs=rep(1,length(all))),silent = T)
    if(!is(merged,"try-error") & show_merged) plot(merged,add=T)
  }else{
    for(tag in names(sp)){
      pols_df <- sp[[tag]]
      ydays <- yday(as.Date(pols_df$date.long))
      cols <- df_cols$col[ydays]
      plot(pols_df,add=T,col=cols,border=cols)
      all <- sp::SpatialPolygons(pols_df@polygons)
      merged <- try(maptools::unionSpatialPolygons(all,IDs=rep(1,length(all))),silent = T)
      if(!is(merged,"try-error") & show_merged) plot(merged,add=T)
    }
  }
}
