textp <- function(text,xp,yp,adj=0,total.reg=F,...){
  opar <- par()
  if(total.reg){
    par(new=T,mar=c(0,0,0,0),fig=c(0,1,0,1))
    oceanmap:::empty.plot()
  }
  if(missing(yp)) yp <- xp
  u <- par()$usr
  xlim <- u[1:2]; 
  ylim <- u[3:4]; 
  
  if(abs(xp) > 1 & abs(yp) > 1) xp <- xp/100; 
  if(abs(yp) > 1 & abs(yp) > 1) yp <- yp/100; 
  
  x0 <- xlim[1]+xp*diff(xlim); #if(par()$xlog) x0 <- exp(x0)
  y0 <- ylim[1]+yp*diff(ylim); #if(par()$ylog) y0 <- exp(y0)
  if(par()$xlog) x0 = 10^(xp*(xlim[2] - xlim[1]) + xlim[1])
  if(par()$ylog) y0 = 10^(yp*(ylim[2] - ylim[1]) + ylim[1])
 
  text(x0,y0,text,adj=adj,xpd=T,...)
  if(total.reg) suppressWarnings(par(opar))
}




### see also midtext! for putting text on entire frame range

abline.global <- function(a = NULL, b = NULL, h = NULL, v = NULL, reg = NULL, 
                          coef = NULL, untf = FALSE,mar=c(0,0,0,0), ...){
  opar <- par()
  par(new=T,mar=mar,fig=c(0,1,0,1))
  oceanmap:::empty.plot(xlim=c(0,1),ylim=c(0,1))
  if(!is.null(h)){if(h > 1) h <- h/100}
  if(!is.null(v)){if(v > 1) v <- v/100}
  abline(a=a, b=b, h=h, v=v, reg=reg,coef=coef, untf=untf, ...)
  suppressWarnings(par(opar))
}