yday2month.axis <- function(years=0,months,vline=1.5,lwd=2,lty=1,col=col,Labels=T,tck.long=.05, month.grid=F,xpd=T,...){
  ## plots month axes on indexed dates (1:366, or > 366 if more then one year is selected)
  library('lubridate')
  lct <- Sys.getlocale("LC_TIME"); Sys.setlocale("LC_TIME", "C")
  d <- c()
  for (y in years) d <- c(d, as.Date(paste0(y,"-",1:12,"-01")))
  d <- c(d,as.Date(paste0(max(years),"-12-31")))
  dates <- as.Date(d[1]:tail(d,1),origin="1970-01-01")
  ydd <- d <- as.Date(d,origin="1970-01-01")
  
  if(!missing(months)){
    if(!(12 %in% months)){
      ydd <- num2date(month2date(months,years)[1]:month2date(months+1,max(years))[length(months)]-1)
    } else{
      ydd <- num2date(month2date(months,years)[1]:(month2date(months,max(years))[length(months)]+1))
    }
  }else{
    months <- unique(date2month(d))
  }
#   }else{
#     ydrange <- par()$usr[1:2]; date.range <- yday2date(ydrange,year = years)
#     ydd <- date.range[1]:date.range[2]
#   }
  
  ydays <- lubridate::yday(dates); #ydays <- ydays[ydays %in% ydd]
  xticks <- which(dates %in% d & dates %in% ydd)
  short_xticks <- which(dates %in% d & dates %in% ydd & ydays != 1 & ydays != tail(ydays,1))
  if(!(12 %in% months)) short_ticks <- c(short_xticks, lubridate::yday(tail(ydd,1)))
  
  long_xticks <- which(dates %in% d & dates %in% ydd & ydays == 1)
  if(12 %in% months) long_ticks <- c(long_xticks, length(ydays))
  
  short_xticks <- short_xticks[which(short_xticks >= par()$usr[1] & short_xticks <= par()$usr[2])]
  long_xticks <- long_xticks[which(long_xticks >= par()$usr[1] & long_xticks <= par()$usr[2])]
  if(month.grid) abline(v=short_xticks)
  
  # xticks.labels <- format(d,"%d-%b")
  #   plot(1:730,axes=F)
  axis(1,at=short_xticks,labels=F,lwd=0,lwd.ticks=1,xpd=xpd,...)
  axis(1,at=long_xticks,labels=F,tck=-tck.long,xpd=T,...)
  
#   nticks <- 1:(length(xticks)-1)
  xticks.labels2 <- format(d,"%b")[which(d %in% ydd)]
  d2 <- lubridate::yday(d)
  xticks2 <- (d2[1:(length(d2)-1)]+diff(d2)/2)[which(d %in% ydd)]

if(!Labels) xticks.labels2[1:length(xticks.labels2)] <- ""
  axis(1,at=xticks2,labels=xticks.labels2,lwd=0,lwd.ticks=0,xpd=T,las=0,...) # month label
  #   if(!missing(vline))abline(v=xticks[vline],lwd=lwd,lty=lty,col=col)
  if(length(years) > 1){
    year.dat <- date2year(dates)
    for(y in years){
      i <- which(year.dat == y)
      # axis(1,at=mean(i),line=vline,tick=0,labels=y,font=2,...)
    } 
  }
}


yday2week.axis <- function(side=1,year){
  df_week <- data.frame(yday=ceiling(par()$usr[1]):trunc(par()$usr[2]))
  df_week$date <- yday2date(df_week$yday,year)
  df_week$week <- lubridate::isoweek(df_week$date)
  df_week$mean_yday <- week2yday(df_week$week,year)
  sm <- ddply(df_week,.(week),function(x)c(min_yday=min(x$yday),n=nrow(x)))
  sm <- sm[which(sm$n == 7),]
  axis(side = side,at=sm$min_yday-.5,labels=rep('',nrow(sm)),lwd=0,lwd.ticks = 1)
  
  weeks <- pretty(df_week$week); weeks <- weeks[which(weeks %in% df_week$week)]
  week_ticks <- unique(df_week$mean_yday[which(df_week$week %in% weeks)])
  
  axis(side,at=week_ticks,labels = weeks,lwd=0,lwd.ticks = 0)
}




# 
# 
# month.colorbar <- function(cbx,cby,pal="year.jet",cex.cb.ticks=0.7){
#   inst.pkg('lubridate')
#   lct <- Sys.getlocale("LC_TIME"); Sys.setlocale("LC_TIME", "C")
#   d <- as.Date(c(paste0("2012-",1:12,"-01"),"2012-12-31"))
#   xticks <- yday(d)
#   #   plotmap("medw4")
#   k <- set.colorbar(cbx=cbx,cby=cby,ticks=xticks,labels=rep("",length(xticks)),pal=pal)
#   xticks.labels2 <- format(d,"%b")[1:12]
#   ticks.pos <- seq(cbx[1],cbx[2],length=length(xticks)) # set tick positions
#   xticks2 <- ticks.pos[1:12]+(ticks.pos[2:13]-ticks.pos[1:12])/2
#   
#   pos <- get.cb.pos(cbx,cby,k$oticks)
#   text(xticks2,rep(pos$ticks.lab,12),xticks.labels2,cex=cex.cb.ticks,xpd=T) #plot labels
#   
#   #   set.colorbar(cbx=cbx,cby=cby,ticks=xticks2,labels=xticks.labels2)
# }

