year.colorbar <- function(cbx,cby,cex.cb.ticks=1,cb.title="",cb.xlab="",...){
  library(oceanmap)
  data(cmap)
  days <- as.Date("0-1-1")+0:365
  ticks <- c(which(date2day(days) == 1),365)
  #     ticks2 <- c(1,ticks[1:12]+diff(ticks)/2,365)
  df.ticks <- data.frame(ticks=ticks,label="")
  ticks2 <- c(which(date2day(days) == 15))
  add <- data.frame(ticks=ticks2,label=num2month(1:12,abbrev = T))
  df.ticks <- rbind(df.ticks,add)
  df.ticks <- unique(df.ticks[order(df.ticks$ticks),])
  
  set.colorbar(cbx,cby,pal="year.jet",ticks=ticks,cb.xlab=cb.xlab,cb.title=cb.title,labels=rep("",length(ticks)),...)
  set.colorbar(cbx,cby,pal="year.jet",ticks=df.ticks$ticks, cb.ticks.length = 0,cb.ticks.lwd=0,cex.cb.ticks=cex.cb.ticks,cb.xlab="",cb.title="",labels=df.ticks$label,...)
}

year.colorbarp <- function(cbxp,cbyp,total.reg = F,cex.cb.ticks=1,cb.title="",cb.xlab="",font=1,...){

  library(oceanmap)
  data(cmap)
  days <- as.Date("0-1-1")+0:365
  ticks <- c(which(date2day(days) == 1),365)
  #     ticks2 <- c(1,ticks[1:12]+diff(ticks)/2,365)
  df.ticks <- data.frame(ticks=ticks,label="")
  ticks2 <- c(which(date2day(days) == 15))
  add <- data.frame(ticks=ticks2,label=num2month(1:12,abbrev = T))
  df.ticks <- rbind(df.ticks,add)
  df.ticks <- unique(df.ticks[order(df.ticks$ticks),])
  set.colorbarp(cbxp,cbyp,total.reg = total.reg,pal="year.jet",ticks=ticks,cb.xlab=cb.xlab,cb.title=cb.title,labels=rep("",length(ticks)),font=font,...)
  set.colorbarp(cbxp,cbyp,total.reg = total.reg,pal="year.jet",ticks=df.ticks$ticks, cb.ticks.length = 0,cex.cb.ticks=cex.cb.ticks,cb.xlab="",cb.title="",labels=df.ticks$label,...)
}